import { select, json, geoPath, geoAlbersUsa } from 'd3';
import { feature } from 'topojson';

// Selecting SVG from the HTML code
const svg = select('svg');

// Create a new geoNaturalEarth1() object for generating and projecting paths.
const projection =  d3.geoAlbersUsa().scale(780).translate([200, 100]);
const pathGenerator = geoPath().projection(projection);

// Fetches the data from the end point and then formats it project on the canvas.
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
  .then(data => {
  	// Extracts all the countries in the world.
    const countries = feature(data, data.objects.countries);
  	// Extracts USA from the countries list.
  	const features = countries.features.filter(el => el.properties.name === 'Kazakhstan');
  	// Passes the extracted countries as data for generating the paths on the canvas  
  		svg.selectAll('path').data(features)
      .enter().append('path')
      .attr('class', 'country')
      .attr('d', pathGenerator);
  });